<template>
  <q-card flat class="q-pa-sm q-mt-lg rounded-borders-10">
    <q-card-section>
      <div class="row">
        <div class="col-6">
          <label class="title-headline"> Upload CV / Resume </label>
        </div>

        <div class="col-6" align="right">
          <q-btn
            unelevated
            size="md"
            icon="eva-edit-outline"
            class="btn-edit text-grey"
            @click="showUploadResume(), (showUploadResumeDialog = true)"
          />
        </div>
      </div>
    </q-card-section>

    <div class="row q-px-md q-my-md">
      <div class="col q-mr-md">
        <q-btn
          unelevated
          block
          label="VIEW"
          style="width: 100%"
          class="btn--shade-2 btn-lg text-white q-mr-lg"
          :disable="!userStore.userDetails.cv_or_resume_url"
          @click="openFile(userStore.userDetails.cv_or_resume_url)"
        />
      </div>

      <div class="col">
        <q-btn
          unelevated
          block
          label="DOWNLOAD"
          style="width: 100%"
          class="btn--shade-2 btn-lg text-white"
          :disable="!userStore.userDetails.cv_or_resume_url"
          @click="
            downloadFile(
              userStore.userDetails.cv_or_resume_url,
              userStore.userDetails.cv_or_resume
            )
          "
        />
      </div>
    </div>
  </q-card>

  <!-- DIALOG: UPLOAD CV/RESUME -->
  <q-dialog
    v-model="showUploadResumeDialog"
    persistent
    @hide="showUploadResumeDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Upload CV / Resume</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <div>
          <q-file
            outlined
            v-model="resumeForm.cv_or_resume"
            max-file-size="5242880"
            :rules="[validations.requiredField]"
            :filter="checkFileType"
            @rejected="onRejected(resumeForm.cv_or_resume)"
            @update:model-value="onRejected(resumeForm.cv_or_resume)"
          >
            <template v-slot:prepend>
              <q-icon name="eva-attach-outline" />
            </template>
          </q-file>
          <p id="error" class="q-field_messages text-negative q-pa-sm">
            {{ errorMessage }}
          </p>
        </div>
      </q-card-section>

      <div class="q-my-md" align="center">
        <q-btn
          unelevated
          label="UPLOAD"
          class="btn-lg btn--shade-1 text-white"
          :loading="loading"
          @click="confirmUploadResume(resumeForm)"
        />
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, ref, reactive } from "vue";
import { useUser } from "src/layouts/portals/store/user";
import { requiredField } from "src/hooks/validations";
import useJobseekerHook from "../../hooks/jobseekerHook";
import downloadjs from "downloadjs";

export default defineComponent({
  setup() {
    const userStore = useUser();
    const { getBasicInfo } = userStore;
    const { loading, doUpdateResume } = useJobseekerHook();
    const USER_ID = ref(null);
    const showUploadResumeDialog = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");

    const resumeForm = reactive({
      cv_or_resume: null,
      _method: "PUT",
    });

    const fetchUserDetails = () => {
      USER_ID.value = LocalStorage.getItem("auth").id;
      getBasicInfo(USER_ID.value);
    };

    const openFile = (url) => {
      window.open(url);
    };

    const downloadFile = (url, filename) => {
      var x = new XMLHttpRequest();
      x.open("GET", url, true);
      x.responseType = "blob";
      x.onload = function (e) {
        downloadjs(e.target.response, filename);
      };
      x.send();
    };

    const showUploadResume = () => {
      resumeForm.cv_or_resume = null;
    };

    const confirmUploadResume = async (form) => {
      USER_ID.value = LocalStorage.getItem("auth").id;
      const formData = new FormData();
      formData.append(
        "cv_or_resume",
        form.cv_or_resume,
        form.cv_or_resume.name
      );
      formData.append("_method", form._method);

      await doUpdateResume(USER_ID.value, formData);
      showUploadResumeDialog.value = false;
      fetchUserDetails();
    };

    const downloadResume = async (fileInfo) => {
      console.log("fileInfo: ", fileInfo);

      // fetch(fileInfo.cv_or_resume_url)
      //   .then((resp) => resp.blob())
      //   .then((blob) => {
      //     const url = window.URL.createObjectURL(blob);
      //     const a = document.createElement("a");
      //     a.style.display = "none";
      //     a.href = url;
      //     // the filename you want
      //     a.download = "file.pdf";
      //     document.body.appendChild(a);
      //     a.click();
      //     window.URL.revokeObjectURL(url);
      //     alert("your file has downloaded!"); // or you know, something with better UX...
      //   })
      //   .catch(() => alert("oh no!"));

      //   // window.open(form.cv_or_resume_url, "_blank");
      //   // const linkSource = form.cv_or_resume_url;
      //   // const downloadLink = document.createElement("a");
      //   // const fileName = "vct_illustration.pdf";

      //   // downloadLink.href = linkSource;
      //   // downloadLink.download = fileName;
      //   // downloadLink.click();

      //   // var filePath = form.cv_or_resume_url;
      //   // var save = document.createElement("a");
      //   // save.href = filePath;
      //   // save.download = form.cv_or_resume;
      //   // save.att
      //   // // save.target = "_blank";
      //   // document.body.appendChild(save);
      //   // save.click();
      //   // document.body.removeChild(save);

      var x = new XMLHttpRequest();
      x.open("GET", "https://www.africau.edu/images/default/sample.pdf", true);
      // x.setRequestHeader("Content-Type", "application/x-www-form-urlencode");
      // x.setRequestHeader("Access-Control-Allow-Origin", "*");
      // x.setRequestHeader(
      //   "Access-Control-Allow-Origin",
      //   "http://localhost:8080"
      // );
      // x.setRequestHeader("Access-Control-Allow-Credentials", "true");

      // x.setRequestHeader("Access-Control-Allow-Headers", "Content-Type");
      // // x.setRequestHeader("Access-Control-Allow-Origin", "*");
      // x.setRequestHeader("Access-Control-Allow-Methods", "OPTIONS,POST,GET");
      // x.setRequestHeader(
      //   "Access-Control-Allow-Origin",
      //   "https://vigan-staging-bucket.s3.ap-southeast-1.amazonaws.com"
      // );

      x.responseType = "blob";
      x.onload = function (e) {
        console.log("e: ", e);
        saveAs(x.response, "test.pdf", "application/pdf");
      };
      x.send();

      // const image = await fetch(
      //   "https://www.africau.edu/images/default/sample.pdf"
      // );
      // const imageBlog = await image.blob();
      // const imageURL = URL.createObjectURL(imageBlog);

      // const anchor = document.createElement("a");
      // anchor.href = imageURL;
      // anchor.download = "FILE_NAME.pdf";

      // document.body.appendChild(anchor);
      // anchor.click();
    };

    fetchUserDetails();

    return {
      userStore,
      USER_ID,
      resumeForm,
      loading,
      errorMessage,
      showUploadResume,
      showUploadResumeDialog,
      validations: {
        requiredField,
      },
      checkFileType(files) {
        return files.filter(
          (file) =>
            file.type === "application/msword" ||
            file.type ===
              "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
            file.type === "application/pdf" ||
            file.type === "image/png" ||
            file.type === "image/jpeg" ||
            file.type === "image/jpg"
        );
      },
      onRejected(file) {
        if (
          file.type === "application/msword" ||
          file.type ===
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document" ||
          file.type === "application/pdf" ||
          file.type === "image/png" ||
          file.type === "image/jpeg" ||
          file.type === "image/jpg"
        ) {
          isError.value = false;
          errorMessage.value = "";
        } else {
          isError.value = true;
          errorMessage.value = "The file type uploaded is not supported";
        }
      },
      openFile,
      confirmUploadResume,
      downloadFile,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-edit {
  border-radius: 50px !important;
  padding: 5px !important;
}
</style>
